summaryrefslogtreecommitdiffstats
path: root/.local
diff options
context:
space:
mode:
Diffstat (limited to '.local')
-rwxr-xr-x.local/bin/compiler17
1 files changed, 9 insertions, 8 deletions
diff --git a/.local/bin/compiler b/.local/bin/compiler
index ff76add..3c2d204 100755
--- a/.local/bin/compiler
+++ b/.local/bin/compiler
@@ -4,7 +4,7 @@
# have this script run via vim.
#
# Compiles .tex. groff (.mom, .ms), .rmd, .md, .org. Opens .sent files as sent
-# presentations. Runs scripts based on extention or shebang
+# presentations. Runs scripts based on extention or shebang.
#
# Note that .tex files which you wish to compile with XeLaTeX should have the
# string "xelatex" somewhere in a comment/command in the first 5 lines.
@@ -14,23 +14,24 @@ dir=${file%/*}
base="${file%.*}"
ext="${file##*.}"
-cd "$dir" || exit
+cd "$dir" || exit 1
textype() { \
command="pdflatex"
- ( sed 5q "$file" | grep -i -q 'xelatex' ) && command="xelatex"
+ ( head -n5 "$file" | grep -qi 'xelatex' ) && command="xelatex"
$command --output-directory="$dir" "$base" &&
- grep -i addbibresource "$file" >/dev/null &&
+ grep -qi addbibresource "$file" &&
biber --input-directory "$dir" "$base" &&
$command --output-directory="$dir" "$base" &&
$command --output-directory="$dir" "$base"
}
case "$ext" in
+ # Try to keep these cases in alphabetical order.
[0-9]) preconv "$file" | refer -PS -e | groff -mandoc -T pdf > "$base".pdf ;;
c) cc "$file" -o "$base" && "$base" ;;
- go) go run "$file" ;;
cpp) g++ "$file" -o "$base" && "$base" ;;
+ go) go run "$file" ;;
h) sudo make install ;;
m) octave "$file" ;;
md) if [ -x "$(command -v lowdown)" ]; then
@@ -42,13 +43,13 @@ case "$ext" in
fi ; ;;
mom) preconv "$file" | refer -PS -e | groff -mom -kept -T pdf > "$base".pdf ;;
ms) preconv "$file" | refer -PS -e | groff -me -ms -kept -T pdf > "$base".pdf ;;
+ org) emacs "$file" --batch -u "$USER" -f org-latex-export-to-pdf ;;
py) python "$file" ;;
[rR]md) Rscript -e "rmarkdown::render('$file', quiet=TRUE)" ;;
rs) cargo build ;;
- sass) sassc -a "$file" "$base.css" ;;
+ sass) sassc -a "$file" "$base.css" ;;
scad) openscad -o "$base".stl "$file" ;;
sent) setsid -f sent "$file" 2>/dev/null ;;
tex) textype "$file" ;;
- org) emacs "$file" --batch -u "$USER" -f org-latex-export-to-pdf ;;
- *) sed 1q "$file" | grep "^#!/" | sed "s/^#!//" | xargs -r -I % "$file" ;;
+ *) head -n1 "$file" | grep "^#!/" | sed "s/^#!//" | xargs -r -I % "$file" ;;
esac